#ifndef	__IR_H__
#define	__IR_H__
//*******************************************************
//
//	IrCtrl2
//
//	Ir信号処理
//
//	MCU : ATmega88
//		efuse:F5h
//		hfuse:D5h	BOD 2.7V
//		lfuse:E7h	4MHz セラロック
//
//	Compiler:	AVR-GCC		4.8.2
//				AVR-LIBC	1.8.0
//				binutils	2.23.1
//
//	2014.6.14	KAWAKAMI Yukio
//*******************************************************

// Ir送信パルス幅指定	単位は 38kHzパルスの数	26.3us単位
#define	IR_NEC_T	21		// T @38kHzパルス個数
#define	IR_NEC_T3	64		// T x 3
#define	IR_NEC_T8	171		// T x 8
#define	IR_NEC_T16	342		// T x 16

#define	IR_AEHA_T	16		// T @38kHzパルス個数
#define	IR_AEHA_T3	48		// T x 3
#define	IR_AEHA_T4	65		// T x 4
#define	IR_AEHA_T8	129		// T x 8

// Ir受信パルス幅指定	単位は 4MHz/64 16us単位
#define	IR_NEC_RECV_T_MIN	28	// 562 x 0.8
#define	IR_NEC_RECV_T		35	// 562us
#define	IR_NEC_RECV_T_MAX	42	// 562 x 1.2

#define	IR_AEHA_RECV_T_MIN	21	// 350us
#define	IR_AEHA_RECV_T		27	// 425us
#define	IR_AEHA_RECV_T_MAX	32	// 500us

//#define	IR_TIMEOUT	76	// 2ms @38kHzパルス
#define	IR_TIMEOUT	228		// 6ms


#define	IR_FORMAT_NEC	1
#define	IR_FORMAT_AEHA	2
#define	IR_FORMAT_SONY	3

#define	IR_DATA_MAXLEN	8

typedef struct S_IR_DATA {
	uchar	format;
	uchar	len;
	uchar	data[IR_DATA_MAXLEN];
} IR_DATA;


void ir_send(PGM_VOID_P ir_data);
void ir_pulse(uchar width);

int ir_equal(IR_DATA *data, PGM_VOID_P code);

void hex2(uchar d, char *buff);

void job_ir(void);

#endif	// __IR_H__
