#ifndef	__MAIN_H__
#define	__MAIN_H__
//*******************************************************
//
//	IrCtrl2
//
//	MCU : ATmega88
//		efuse:F5h
//		hfuse:D5h	BOD 2.7V
//		lfuse:E7h	4MHz セラロック
//
//	Compiler:	AVR-GCC		4.8.2
//				AVR-LIBC	1.8.0
//				binutils	2.23.1
//
//	2014.9.9	KAWAKAMI Yukio
//*******************************************************

#define		VERSION		"2.0.8"


#define		F_CPU	4000000UL	// 4MHz

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef unsigned short	ushort;
typedef	unsigned long	ulong;

// ポート設定
// PORTB
#define	LED		0

// PORTC
#define	SOUT2	3
#define	SOUT1	2
#define	LIN2	1
#define	LIN1	0

// PORTD
#define	IR			7
#define	DEBUG_PORT	6
#define	IR_OUT		3
#define	TXD			1
#define	RXD			0

#define	POWER_SW_ON		PORTC |= (1<<SOUT1)
#define	POWER_SW_OFF	PORTC &= ~(1<<SOUT1)
#define	REC_SW_ON		PORTC |= (1<<SOUT2)
#define	REC_SW_OFF		PORTC &= ~(1<<SOUT2)
#define	IS_POWER_LED	(!(PINC & (1<<LIN1)))
#define	IS_REC_LED		(!(PINC & (1<<LIN2)))
#define	IS_IR			((ACSR & (1<<ACO)))		// アナログコンパレータ
#define	LED_ON			PORTB |= (1<<LED)
#define	LED_OFF			PORTB &= ~(1<<LED)
#define	IS_LED_ON		(PORTB & (1<<LED))

#define	IR_OUT_ON		TCCR2A |= (1<<COM2B1)
#define	IR_OUT_OFF		TCCR2A &= ~(1<<COM2B1)

#define	DEBUG_ON	PORTD |= (1<<DEBUG_PORT)
#define	DEBUG_OFF	PORTD &= ~(1<<DEBUG_PORT)

void cputs(PGM_P msg);
void wait_timer(uchar tm);

#endif	// __MAIN_H__
