#ifndef	__TASK_H__
#define	__TASK_H__
//*******************************************************
//
//	IrCtrl2
//
//	処理タスク
//
//	MCU : ATmega88
//		efuse:F5h
//		hfuse:D5h	BOD 2.7V
//		lfuse:E7h	4MHz セラロック
//
//	Compiler:	AVR-GCC		4.8.2
//				AVR-LIBC	1.8.0
//				binutils	2.23.1
//
//	2014.9.9	KAWAKAMI Yukio
//*******************************************************

// 処理シーケンスの待ち時間
#define		POWER_ON_WAIT	27	// Ir信号が来てから電源ONするまで待つ時間
#define		READY_WAIT		27	// 録画可能になるまで待つ最大時間
#define		REC_WAIT		50	// IrのREC信号が来てから録画開始する時間(秒)
#define		REC_START_TIME	5	// 録画開始時間
#define		SHUTDOWN_WAIT	60	// 録画停止後、電源OFFする時間
#define		POWER_OFF_TIME	10	// 電源OFFに必要な時間(秒)

#define		SWITCH_TIME		100	// ボタンをONにしている時間(1/100秒単位)

#define	STAT_POWEROFF		0
#define	STAT_POWERONWAIT	1
#define	STAT_WAITPOWERON	2
#define	STAT_WAITRECREADY	3
#define	STAT_STARTING		4
#define	STAT_READY			5
#define	STAT_RETURN			6
#define	STAT_STARTREC		7
#define	STAT_REC			8
#define	STAT_TUNER_ON		9
#define	STAT_STOPREC		10
#define	STAT_SAVE			11
#define	STAT_SHUTDOWN		12

#define	STAT_ERROR			99


#define	COMMAND_START		1
#define	COMMAND_REC			2
#define	COMMAND_STOP		3
#define	COMMAND_POWEROFF	4


void job_task(void);

void power_on(void);
void start_rec(void);
void stop_rec(void);
void power_off(void);
void force_power_off(void);
void send_return(void);
void send_ok(void);
void tuner_on_off(void);


#endif	// __TASK_H__

